<template>
  <div class="game-module-three w-full overflow-hidden">
    <div
      class="flex item-center gap-2 px-2"
      :class="getAnimationClass"
      :style="{ transform: `translateX(${translateX}px)` }"
      @touchmove="onTouchMove"
      @touchstart="onTouchStart"
      @touchend="onTouchEnd"
    >
      <div
        v-for="(item, index) in moduleFiveDisplayTabs"
        :key="index"
        :data-index="index"
        class="game-module-item relative shrink-0 overflow-hidden rounded-lg"
        :class="{ active: index === activeSlider, [getAnimationClass]: true }"
        @click="onSlideTo(index)"
      >
        <img
          class="absolute w-[200px] h-[181px] bottom-[-20px] object-cover z-0 transition-all duration-500"
          :src="
            getAssetImage(
              `assets/theme/common/LobbySettings/GameModule/bg_${item.Label.toLowerCase().replaceAll(
                ' ',
                '_'
              )}.png`
            )
          "
        />
        <div class="absolute w-full h-full flex justify-center z-1">
          <img
            class="aspect-square h-full transition-all duration-500"
            :src="
              getAssetImage(
                `assets/theme/common/LobbySettings/GameModule/star_${item.Label.toLowerCase().replaceAll(
                  ' ',
                  '_'
                )}.png`
              )
            "
          />
        </div>
        <div
          class="flex flex-col items-center justify-between py-2 h-full z-10 relative"
        >
          <h3 class="font-bold text-sm text-center uppercase text-white">
            {{ $t(item.Label) }}
          </h3>
          <button
            class="game-play-btn h-7 flex items-center rounded px-4 font-bold text-sm tc-btn bg-primary transition-all duration-300"
            @click="onGoGameEntryFilter(item)"
          >
            {{ $t("play_now") }}
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { useGameModule } from "@/composables/lobby/useGameModule";

const { getAssetImage } = commonHelper;
const {
  getTopGameListInitial,
  getNewGameListInitial,
  getmoduleFiveDisplayTabs,
  moduleFiveDisplayTabs,
  onGoGameEntryFilter,
} = useGameModule();
getTopGameListInitial();
getNewGameListInitial();
getmoduleFiveDisplayTabs();

const activeSlider = ref(0);
const translateX = ref(0);
const gap = 8;
const itemWidth = 120;

const getTranslation = (index: number) => {
  const totalCount = moduleFiveDisplayTabs.value?.length ?? 0;
  const offset = window.innerWidth / 2 - 100 - 120 + 12 + 24;
  let value = -(itemWidth / 2 - gap) - (itemWidth + gap) * (index - 1) + offset;
  if (index === totalCount - 1) {
    value += 62;
  }

  return value;
};

const handleCenterSlideItem = () => {
  if (activeSlider.value !== 0) {
    translateX.value = getTranslation(activeSlider.value);
  } else {
    translateX.value = 0;
  }
};

let interval: NodeJS.Timeout;
const isTouchMoving = ref(false);
const getAnimationClass = computed(() => {
  if (isTouchMoving.value) return "";
  return "transition-all duration-[800ms] smart-animation";
});

const createAutoSlide = () => {
  clearTimeout(interval);
  interval = setInterval(() => {
    const totalCount = moduleFiveDisplayTabs.value?.length ?? 0;
    if (activeSlider.value < totalCount - 1) {
      activeSlider.value += 1;
    } else {
      activeSlider.value = 0;
      // To reset auto slide, in some case after reach 0 it will immediately go to second slide.
      createAutoSlide();
    }
    handleCenterSlideItem();
  }, 1500);
};

createAutoSlide();

const onSlideTo = (index: number) => {
  if (activeSlider.value === index) return;
  activeSlider.value = index;
  handleCenterSlideItem();
  createAutoSlide();
};

let initialX: number | null = null;
const checkCenterElement = () => {
  const eles = document.querySelectorAll(".game-module-item");
  const threshold = 100;
  eles.forEach((element) => {
    const viewportWidth = window.innerWidth;

    const observer = new IntersectionObserver(
      (entries, observer) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting && entry.intersectionRatio > 0.5) {
            const elementCenter =
              element.getBoundingClientRect().left + element.offsetWidth / 2;
            const isCentered =
              Math.abs(elementCenter - viewportWidth / 2) < threshold;

            if (isCentered) {
              // Perform your desired action here (e.g., add a class for styling)
              // Optionally stop observing after centered:
              activeSlider.value = Number(element.getAttribute("data-index"));
              handleCenterSlideItem();
              observer.unobserve(element);
            }
          }
        });
      },
      {
        root: null,
        threshold: 0.01,
      }
    );

    observer.observe(element);
  });
};
const onTouchStart = () => {
  isTouchMoving.value = true;
  clearTimeout(interval);
};

const onTouchEnd = () => {
  createAutoSlide();
  initialX = null;
  if (isTouchMoving.value) {
    checkCenterElement();
  }
  isTouchMoving.value = false;
};

const onTouchMove = (event: any) => {
  if (event.touches.length !== 1) {
    return; // Only handle single touch
  }

  const touch = event.touches[0];

  if (initialX === null) {
    // Capture initial X position on first touch move
    initialX = touch.clientX - translateX.value;
  }

  const deltaX = touch.clientX - initialX!;
  if (deltaX >= 0) {
    translateX.value = 0;
    return;
  }
  const lastIndex = (moduleFiveDisplayTabs.value?.length ?? 0) - 1;
  const minTransition = getTranslation(lastIndex);

  if (deltaX <= minTransition) {
    translateX.value = minTransition;
    return;
  }

  // Use deltaX for your logic to track the movement
  translateX.value = deltaX;
};
</script>

<style lang="scss">
.game-module-three {
  .game-module-item {
    width: 120px;
    height: 120px;

    &:not(.active) {
      .game-play-btn {
        opacity: 0;
      }
    }

    &.active {
      width: 200px;
    }
  }
}
</style>
